<!DOCTYPE html>
<html>
<head>
  <meta charset = "utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>
<body>
<div class="container">
  <h2>Registration Car Form</h2>

  <div class="jumbotron container"> 
    <div class="row form-group">
      <div class="col-sm-3">
        <label for="input-fname">First Name</label>
      </div>
      <div class="col-sm-9">
        <input type="text" id="input-fname" name="firstname" placeholder="Your first name ..." class="form-control">
      </div>
    </div>
    <div class="row form-group">
      <div class="col-sm-3">
        <label for="input-lname">Last Name</label>
      </div>
      <div class="col-sm-9">
        <input type="text" id="input-lname" name="lastname" placeholder="Your last name ..." class="form-control">
      </div>
    </div>
    <div class="row form-group">
      <div class="col-sm-3">
        <label for="country-select">Country</label>
      </div>
      <div class="col-sm-3">
        <select id="country-select" name="country" class="form-control">
        </select>
      </div>
      <div class="col-sm-3">
        <label for="region-type-select">Region</label>
      </div>
      <div class="col-sm-3">
        <select id="region-type-select" name="region" class="form-control">
        </select>
      </div>
    </div>
    <div class="row form-group">
      <div class="col-sm-3">
        <label for="car-select">Car</label>
      </div>
      <div class="col-sm-3">
        <select id="car-select" name="car" class="form-control">
        </select>
      </div>
      <div class="col-sm-3">
        <label for="car-type-select">Car type</label>
      </div>
      <div class="col-sm-3">
        <select id="car-type-select" name="car-type" disabled class="form-control">
        </select>
      </div>
    </div>
    <div class="row">
      <div class="col-sm-12" style="text-align: right;">
        <button class="btn btn-info"> Send </button>
      </div>
    </div>
  </div>
</div>
</body>

<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  // car brand information
  var gJsonCarData = `[
                          {"brandId": "0","brandName": "None", "brandTypes": []}, 
                          {"brandId": "1","brandName": "Audi", "brandTypes": [{"typeId":"0", "typeName":"Q3"},{"typeId":"1","typeName":"Q5"},{"typeId":"2","typeName":"A4"}]},
                          {"brandId": "2","brandName": "BMW", "brandTypes": [{"typeId":"0","typeName":"1 series"},{"typeId":"1","typeName":"X series"},{"typeId":"2","typeName":"Z series"}]},
                          {"brandId": "3","brandName": "Citroen", "brandTypes": [{"typeId":"0","typeName":"new C3"},{"typeId":"1","typeName":"C4"},{"typeId":"2","typeName":"BERLINGO"}]}
                        ]`;
  
  // country information
  var gJsonCountryData = `[
                            {"countryId": "0","countryName": "None", "regionTypes": []}, 
                            {"countryId": "1","countryName": "Việt nam", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0", "regionName":"Hà Nội"},
                                                                          {"regionId":"1","regionName":"Hồ Chí Minh"},
                                                                          {"regionId":"2","regionName":"Đà Nẵng"}]},
                            {"countryId": "2","countryName": "Mỹ", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0","regionName":"Atlanta"},
                                                                          {"regionId":"1","regionName":"New York"},
                                                                          {"regionId":"2","regionName":"Boston"}
                                                                        ]},
                            {"countryId": "3","countryName": "Phần lan", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0","regionName":"Nam Phần Lan"},
                                                                          {"regionId":"1","regionName":"Tây Phần Lan"},
                                                                          {"regionId":"2","regionName":"Đông Phần Lan"}
                                                                        ]}
                          ]`;
  
  var gObjectCarData = JSON.parse(gJsonCarData);
  var gObjectCountryDate = JSON.parse(gJsonCountryData);

  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
  $(document).ready(function(){
	  // Đoạn mã sẽ thực thi sau khi tải tài liệu
    onPageLoading();
      $("#car-select").change(function() {
        displaySelectCarValue();
      });
      $(".btn").click(function() {
        onBtnSendClick();
      });
      $("#country-select").change(function() {
        displaySelectCoutryValue(this);
      });
    });
  //hàm xử lý sự kiện send click
  function onBtnSendClick(){
    //khai báo dối tượng chứa dữ liệu
    var formDataObject = {
        brandId: "",
        brandName: "",
        typeId: "",
        typeName: "",
        countryId: "",
        countryName: "",
        regionId: "",
        regionName: ""
      };
    //b1 thu thập dữ liệu
    getformData(formDataObject);
    //b2 validate nếu có
    //b3 hiện thị front-end
    showDataToConsole(formDataObject);
  }
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // Hàm xử lý sự kiện khi tải trang
    function onPageLoading() {
      loadCarSelect();
      loadDataCountrySelect();
    }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

    function loadCarSelect(){
      //console.log (gObjectCarData);
      var vCarSelect = $("#car-select");
      for (var bI = 0; bI < gObjectCarData.length; bI ++){
        // Xử lý tạo ra thẻ option, gắn thuộc tính value và innerHTML (html)
        $("<option>", {html: gObjectCarData[bI].brandName, value: gObjectCarData[bI].brandId}).appendTo(vCarSelect);
      }
    }

    function loadDataCountrySelect(){
      "use strict"
      var vCountrySelect = $("#country-select")
      for(let bI= 0;bI<gObjectCountryDate.length;bI++){
        var bCountryOption =$("<option/>",{
          value: gObjectCountryDate[bI].countryId,
          text: gObjectCountryDate[bI].countryName,
        })
        vCountrySelect.append(bCountryOption)
      }
    }
    // Hiển thị giá trị của ô select car
    function displaySelectCarValue(){
      console.log ($("#car-select").val());

      // Tìm thẻ select có id = car-select
      var vSelectCarValue = $("#car-select").val();

      //Lấy brand type theo ID:
      var vBrandCarType = getBrandTypeByBrandID (vSelectCarValue);

      console.log(vBrandCarType);
      var vCarTypeSelect = $("#car-type-select");
      //Xóa rỗng
      vCarTypeSelect.html("");
      vCarTypeSelect.prop ("disabled", false);

      if (vBrandCarType.length>0){
        for (var bI = 0; bI < vBrandCarType.length; bI++){
          $("<option>", {html: vBrandCarType[bI].typeName, value: vBrandCarType[bI].typeId}).appendTo(vCarTypeSelect);
        }
      } else {
        vCarTypeSelect.prop ("disabled", "disabled");
      }
      
    }
    //Hiển thị giá trị của ô select country
    function displaySelectCoutryValue(paramSelectCoutry){
      //B1L Thu thập dữ liệu
      var vCountryId = $(paramSelectCoutry).val()
      console.log("countryID: "+ vCountryId)
      //b2 validate(nếu có )
      //b3 xử lý frontend
      loadDataToRegionTypeSelectByCountryId(vCountryId)
    }
    // In ra console
    function writeToConsole(){
      var vCarSelect = $("#car-select");
      var vCarTypeSelect = $("#car-type-select");
      
      var vBrandId = vCarSelect.val();
      var vBrandName = $("#car-select option:selected").text();
      console.log ("Brand Id:" + vBrandId);
      console.log ("Brand name: " + vBrandName);

      var vTypeId = vCarTypeSelect.val();
      var vTypeName = $("#car-type-select option:selected").text(); 
      console.log ("Type Id:" + vTypeId);
      console.log ("Type name: " + vTypeName);
    }
    /**
   * get brandType by brandId
   * input: brandId of a car
   * output: brandType name of found car. If not found, it returns null
   */
  function getBrandTypeByBrandID(paramBrandId) {
    var vBrandFound = false;
    var vBrandTypesResult = null;
    var vIterator = 0;
    while (!vBrandFound && vIterator < gObjectCarData.length) {
        if (gObjectCarData[vIterator].brandId === paramBrandId) {
          vBrandFound = true;
          vBrandTypesResult = gObjectCarData[vIterator].brandTypes;
        }
        else {
          vIterator ++;
        }
    }
    return vBrandTypesResult;
  }
  function loadDataToRegionTypeSelectByCountryId(paramCountryId){
  var vRegionTypesData = getRegionTypesByCountryID(paramCountryId);
  var vElementSelectRegion = $("#region-type-select");
  vElementSelectRegion.html("");
  if(vRegionTypesData.length == 0){
    vElementSelectRegion.prop("disabled", true);
  } else {
    vElementSelectRegion.prop("disabled", false);
    for(var bI = 0; bI < vRegionTypesData.length; bI++){
      var bRegionOption = $("<option/>", {
        value: vRegionTypesData[bI].regionId,
        text: vRegionTypesData[bI].regionName,
      });
      vElementSelectRegion.append(bRegionOption);
    }
  }
}
  function getRegionTypesByCountryID(paramCountryId){
  var vRegionFound = false;
  var vRegionTypesResult = null;
  var vIterator = 0;
  while(!vRegionFound && vIterator < gObjectCountryDate.length){
    if(gObjectCountryDate[vIterator].countryId === paramCountryId){
      vRegionFound = true;
      vRegionTypesResult = gObjectCountryDate[vIterator].regionTypes;
    } else {
      vIterator++;
    }
  }
  return vRegionTypesResult;
}
  function getformData(paramFormObj){
   

      paramFormObj.brandId =$("#car-select").val()
      paramFormObj.brandName =$("#car-select option:selected").text()
      paramFormObj.typeId =$("#car-type-select").val()
      paramFormObj.typeName =$("#car-type-select option:selected").text()

      paramFormObj.countryId =$("#country-select").val()
      paramFormObj.countryName =$("#country-select option:selected").text()
      paramFormObj.regionId =$("#region-type-select").val()
      paramFormObj.regionName =$("#region-type-select option:selected").text()
  }
  function showDataToConsole(paramFormObj){
    console.log(paramFormObj)
    console.log("countryId: " + paramFormObj.countryId)
    console.log("countryName: "+paramFormObj.countryName)
    console.log("regionId: "+ paramFormObj.regionId)
    console.log("regionName: " +paramFormObj.regionName)

  }
</script> 

</html>
